import pygtk
pygtk.require("2.0")
import gtk
import pango
import dictclient

    
        
class DictClient:
    def destroy(self, widget, data=None):
        gtk.main_quit()

    def delete_event (self, widget, event, data=None):
        print "delete event"
        return gtk.FALSE

    def on_search_clicked(self, widget, data = None):
        buff = gtk.TextBuffer()
        res = self.dictclient.define("*", self.word.get_text())
        s = ""
        for defin in res:
            s = "--- Server " + str(defin.getdb().getname()) + " gives for " \
                + str(defin.getword()) + ":\n"
            buff.insert_at_cursor(s)
            buff.insert_at_cursor(defin.getdefstr() + "\n\n\n")
        self.result.set_buffer(buff)
        pass
        
    def __init__(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("destroy", self.destroy)
        self.window.set_border_width (10)

        self.vbox = gtk.VBox(False, 10)
        self.hbox = gtk.HBox(False, 10)
        self.word = gtk.Entry()
        self.search = gtk.Button("Search!")
        self.search.connect("clicked", self.on_search_clicked)
        self.result = gtk.TextView()

        self.hbox.pack_start(self.word, False, False)
        self.hbox.pack_start(self.search, False, False)
        self.word.show()
        self.search.show()
        self.vbox.pack_start (self.hbox)
        self.hbox.show()
        self.result.set_size_request(640, 480)
        self.result.set_editable(False)
        self.scrollWin = gtk.ScrolledWindow()
        self.scrollWin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.scrollWin.set_border_width(10)
        self.scrollWin.add(self.result)
        self.scrollWin.show()
        self.vbox.pack_start(self.scrollWin)
        self.result.show()
        self.window.add(self.vbox)
        self.vbox.show()
        self.window.show()
        self.dictclient = dictclient.Connection("dict.org")
    def main(self):
        gtk.main()

dc = DictClient()
dc.main()
