# Esempio di utilizzo di list--comprehension, filter, map, reduce

import sys

primes = [2]

fibo = [0, 1]

def is_prime(num):
    for i in primes:
        if num % i == 0:
            return False
    primes.append(num)
    return True

def my_sum(a, b):
    return a+b


def fibonacci(a,b):
    if len(fibo) < 10:
        fibo.append(a+b)
    return b

a = range(2,100)
even = [x for x in a if x%2 == 0]
odd = [x for x in a if x not in even]

print a
print "-+"*30
print even
print "-+"*30
print odd
print "-+"*30

pr = map(is_prime, odd)
square = lambda x: x**2

for num, prime in zip(odd, pr):
    print "%4d %6s %6d" % (num, prime, square(num))

#sys.exit()

prime_sum = reduce(my_sum, primes)
square_sum = reduce(my_sum, [square(x) for x in primes])
print "-+"*30
print "%4d %6s %6d " % (prime_sum, "", square_sum)

print "+-"*30

primes = [2]
ps = filter(is_prime, odd)
print ps
print "+-"*30

a = reduce(fibonacci, fibo)
print a


