import sys
import Image
import os.path as path


def main ():
    if len(sys.argv) < 3:
        print "Usage: %s <thumb_size> <filename> ...." % sys.argv[0]
        sys.exit(1)
    x, y = sys.argv[1].split("x")
    print "x:", x, "y:", y
    for img in sys.argv[2:]:
        try:
            im = Image.open(img)
            im.thumbnail ((int(x),int(y)))
            dirname= path.dirname(img)
            tmp = path.basename(img).split(".")
            out_file = dirname+"/"+tmp[0]+"_thumb."+tmp[1]
            im.save(out_file, "JPEG")
        except:
            print "Unable to load an image from %s" % image

if __name__ == "__main__":
    main()
