# Esempio di definizione di classi, derivazione, metodi,
# attributi etc....

class Language:
    def __init__ (self, name, version = None):
        self.__name = name
        self.__version = version
        self.__parent = None
    def get_name(self):
        return self.__name
    def get_version(self):
        return self.__version
    def set_version(self, version):
        self.__version = version
    def set_parent_language(self, parent):
        self.__parent = parent
    def get_parent_language (self):
        return self.__parent

class Functional_Language(Language):
    def __init__ (self, name, version = None):
        Language.__init__(name, version)


class ImperativeLanguage(Language):
    def __init__ (self, name, version= None):
        Language.__init__(name, version)
        self.__is_compiled = False
    def is_compiled(self):
        return self.__is_compiled
    def set_compiled(self, comp=True):
        self.__is_compiled = comp

class InterpretedLanguage(ImperativeLanguage):
    def __init__ (self):
        pass

class CompiledLanguage(ImperativeLanguage):
    def __init__ (self):
        pass

    
