import sys
import Image
import os.path as path


def main ():
    if len(sys.argv) < 3:
        print "Usage: %s <imagefile> <angle> [<outfile>]" % sys.argv[0]
        sys.exit(1)
    infile = sys.argv[1]
    angle = float(sys.argv[2])
    if len(sys.argv) == 4:
        outfile = sys.argv[3]
    else:
        outfile = path.realpath(infile) + "rot" + angle
    im = Image.open(infile)
    res = im.rotate(angle)
    res.save(outfile, "JPEG")
    pass

if __name__ == "__main__":
    main()
